"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var http_1 = require("../errors/http");
var Controller_1 = __importDefault(require("./Controller"));
var RouterBase_1 = __importDefault(require("./RouterBase"));
var AwsSamRouter = /** @class */ (function (_super) {
    __extends(AwsSamRouter, _super);
    function AwsSamRouter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AwsSamRouter.prototype.expose = function () {
        var _this = this;
        return function (event, context) {
            var _a;
            var resource = event.resource, httpMethod = event.httpMethod;
            var controller = (_a = _this.map) === null || _a === void 0 ? void 0 : _a[resource];
            if (!controller) {
                throw http_1.NotImplementedControllerError;
            }
            if (controller instanceof Controller_1["default"]) {
                return controller.getHandler(httpMethod.toLowerCase())(event, context);
            }
            if (typeof controller === 'function') {
                return controller(event, context);
            }
            throw http_1.InvalidController;
        };
    };
    return AwsSamRouter;
}(RouterBase_1["default"]));
exports["default"] = AwsSamRouter;
